/*! Built with http://stenciljs.com */
const { h } = window.saveblobcomponent;

var __awaiter = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
class SaveBlobComponent {
    dataDidChangeHandler(newValue) {
        this.innerOpts = JSON.parse(newValue);
    }
    makeRequest(url, options) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!url) {
                throw new Error('No url provided');
            }
            options = options || {};
            try {
                var response = yield fetch(url, {
                    method: options.method || 'get',
                    headers: options.headers || {},
                });
                if (response.ok) {
                    let blob = yield response.blob();
                    return blob;
                }
                throw new Error(response.statusText);
            }
            catch (err) {
                throw err;
            }
        });
    }
    downloadFile( /*event: UIEvent*/) {
        this.makeRequest(this.url, this.innerOpts)
            .then((blob) => {
            if (window.navigator && window.navigator.msSaveOrOpenBlob) {
                // In case of IE or Edge
                this.filename = escape(this.filename);
                window.navigator.msSaveOrOpenBlob(blob, this.filename);
                return;
            }
            var a = document.createElement("a");
            document.body.appendChild(a);
            //a.style = "display: none";
            let url = URL.createObjectURL(blob);
            a.href = url;
            a.download = this.filename;
            a.click();
            window.URL.revokeObjectURL(url);
            document.body.removeChild(a);
        })
            .catch((err) => {
            console.log(err);
        });
    }
    render() {
        if (this.url === undefined) {
            return null;
        }
        let title = this.filename || 'Download';
        return (h("div", null,
            h("button", { onClick: this.downloadFile.bind(this) }, title)));
    }
    static get is() { return "file-downloader"; }
    static get encapsulation() { return "shadow"; }
    static get properties() { return { "filename": { "type": String, "attr": "filename" }, "makeRequest": { "method": true }, "opts": { "type": "Any", "attr": "opts", "watchCallbacks": ["dataDidChangeHandler"] }, "url": { "type": String, "attr": "url" } }; }
    static get style() { return "button[data-file-downloader]{\n    padding: .5rem;\n    background-color: #cc5700;\n    color:#eaeaea;\n\n    border:0;\n}"; }
}

export { SaveBlobComponent as FileDownloader };
